apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "boefjes.fullname" . }}
  labels:
    {{- include "boefjes.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "boefjes.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "boefjes.selectorLabels" . | nindent 8 }}
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "boefjes.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          args:
            - python3
            - -m
            - boefjes
            - boefje
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: http
              containerPort: 80
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /
              port: http
          readinessProbe:
            httpGet:
              path: /
              port: http
          env:
            - name: QUEUE_NAME_BOEFJES
              value: {{ required ".Values.config.queueNameBoefjes is required" .Values.config.queueNameBoefjes }}
            - name: QUEUE_NAME_NORMALIZERS
              value: {{ required ".Values.config.queueNameNormalizers is required" .Values.config.queueNameNormalizers }}
            - name: QUEUE_HOST
              value: {{ required ".Values.config.queueNameBoefjes is required" .Values.config.queueNameBoefjes }}
            - name: OCTOPOES_API
              value: {{ required ".Values.config.octopoesApi is required" .Values.config.octopoesApi }}
            - name: BYTES_API
              value: {{ required ".Values.config.bytesApi is required" .Values.config.bytesApi }}
            - name: KATALOGUS_API
              value: {{ required ".Values.config.katalogusApi is required" .Values.config.katalogusApi }}
            - name: KATALOGUS_DB_URI
              value: {{ required ".Values.config.katalogusDbUri is required" .Values.config.katalogusDbUri }}
            - name: WP_SCAN_API
              value: {{ required ".Values.config.wpScanApi" .Values.config.wpScanApi }}
            - name: ENCRYPTION_MIDDLEWARE
              value: {{ required ".Values.config.encryptionMiddleware is required" .Values.config.encryptionMiddleware }}
            - name: KATALOGUS_PRIVATE_KEY_B_64
              value: {{ required ".Values.config.katalogusPrivateKeyB64 is required" .Values.config.katalogusPrivateKeyB64 }}
            - name: KATALOGUS_PUBLIC_KEY_B_64
              value: {{ required ".Values.config.katalogusPublicKeyB64 is required" .Values.config.katalogusPublicKeyB64 }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
